// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include <mfplay.h>
#include "resource.h"
#include "applicator.h"
#include "lockee.h"
#include "backer.h"
#include "common.h"
#include "dialoger.h"
#include "stater.h"
#include "viewer.h"
#include "framer.h"

BEGIN_MESSAGE_MAP(applicator, CWinApp)
END_MESSAGE_MAP()

applicator::applicator()
{
}

applicator::~applicator()
{
}

BOOL applicator::InitInstance()
{
    CWinApp::InitInstance();

    CoInitialize(NULL); // for Component Object Model

    AddFontResourceEx(get_name(m_hInstance),FR_PRIVATE,NULL);

    // do not allow more instance
    CreateMutex(NULL,FALSE,"thsmhulz");
    if (GetLastError()) return FALSE;

    auto frame = new framer;
    if (frame == NULL) return FALSE;

    m_pMainWnd = frame;
    frame->LoadFrame(IDR_FRAME);
    frame->ShowWindow(SW_SHOW);
    frame->UpdateWindow();

    return TRUE;
}

int applicator::ExitInstance()
{
    RemoveFontResourceEx(get_name(m_hInstance),FR_PRIVATE,NULL);

    CoUninitialize();

    return CWinApp::ExitInstance();
}

applicator application;
