// window of frame

class framer : public CFrameWnd
{
protected:
    viewer                m_view;
    dialoger              m_dialog;
    stater                m_status;
    CFont                 m_font;
    UINT                  m_timer;
    bool                  m_preference_audio;
    bool                  m_preference_video;
    bool                  m_fill_screen;
    bool                  m_full_screen;
    RECT                  m_save_place;
    DWORD                 m_save_style;
    DWORD                 m_save_menu;
    BOOL                  m_save_dialog;
    BOOL                  m_save_status;
    MFVideoNormalizedRect m_save_source;

public:
    framer();
    ~framer();
    BOOL PreCreateWindow(CREATESTRUCT & data);

protected:
    void do_dialog_seek();
    void do_dialog_name();
    void do_status_position();
    void do_status_sound();
    void do_status_scale();
    void do_status_speed();
    void do_format_check();
    void do_repeat_play();
    void do_screen_exit(const bool force);

protected:
    DECLARE_MESSAGE_MAP()
    afx_msg int OnCreate(CREATESTRUCT * data);
    afx_msg void OnClose();
    afx_msg void OnActivateApp(BOOL active, DWORD thread);
    afx_msg void OnKeyDown(UINT character, UINT count, UINT flags);
    afx_msg void OnTimer(UINT_PTR identifier);
    afx_msg void on_update_file_open(CCmdUI * data);
    afx_msg void on_update_file_close(CCmdUI * data);
    afx_msg void on_update_file_attributes(CCmdUI * data);
    afx_msg void on_update_file_components(CCmdUI * data);
    afx_msg void on_update_file_properties(CCmdUI * data);
    afx_msg void on_update_file_statistics(CCmdUI * data);
    afx_msg void on_update_media_increase_sound(CCmdUI * data);
    afx_msg void on_update_media_decrease_sound(CCmdUI * data);
    afx_msg void on_update_media_increase_scale(CCmdUI * data);
    afx_msg void on_update_media_decrease_scale(CCmdUI * data);
    afx_msg void on_update_media_increase_speed(CCmdUI * data);
    afx_msg void on_update_media_decrease_speed(CCmdUI * data);
    afx_msg void on_update_preference_capabilities(CCmdUI * data);
    afx_msg void on_update_preference_audio(CCmdUI * data);
    afx_msg void on_update_preference_video(CCmdUI * data);
    afx_msg void on_update_view_dialog(CCmdUI * data);
    afx_msg void on_update_view_status(CCmdUI * data);
    afx_msg void on_update_view_fill(CCmdUI * data);
    afx_msg void on_update_view_full(CCmdUI * data);
    afx_msg void on_update_dialog_seek(CCmdUI * data);
    afx_msg void on_update_dialog_play(CCmdUI * data);
    afx_msg void on_update_dialog_pause(CCmdUI * data);
    afx_msg void on_update_dialog_stop(CCmdUI * data);
    afx_msg void on_update_dialog_name(CCmdUI * data);
    afx_msg void on_update_status_position(CCmdUI * data);
    afx_msg void on_update_status_sound(CCmdUI * data);
    afx_msg void on_update_status_scale(CCmdUI * data);
    afx_msg void on_update_status_speed(CCmdUI * data);
    afx_msg void on_file_open();
    afx_msg void on_file_close();
    afx_msg void on_file_attributes();
    afx_msg void on_file_components();
    afx_msg void on_file_properties();
    afx_msg void on_file_statistics();
    afx_msg void on_media_increase_sound();
    afx_msg void on_media_decrease_sound();
    afx_msg void on_media_increase_scale();
    afx_msg void on_media_decrease_scale();
    afx_msg void on_media_increase_speed();
    afx_msg void on_media_decrease_speed();
    afx_msg void on_preference_capabilities();
    afx_msg void on_preference_audio();
    afx_msg void on_preference_video();
    afx_msg void on_view_dialog();
    afx_msg void on_view_status();
    afx_msg void on_view_fill();
    afx_msg void on_view_full();
    afx_msg void on_dialog_seek();
    afx_msg void on_dialog_play();
    afx_msg void on_dialog_pause();
    afx_msg void on_dialog_stop();
};
