// implementation of declaration

// for more comments, look at first file

#include <sdkddkver.h>
#include <mfplay.h>
#include "neat.h"
#include "qualifier.h"
#include "hook_2.h"

void hook_take_2();
void hook_give_2();

data_of_hook_2 hook_data_2;

HRESULT STDAPICALLTYPE hook_ours_2(IMFQualityManager ** manager)
{
HRESULT result;

    EnterCriticalSection(&hook_data_2.section);

    hook_give_2();

    result = MFCreateStandardQualityManager(manager);
    if (SUCCEEDED(result))
    {
     qualifier * temp = new qualifier(*manager);
     if (temp)
     {
      *manager = temp; temp = NULL;
     }
    }

    hook_take_2();

    LeaveCriticalSection(&hook_data_2.section);

    return result;
}

void hook_give_2()
{
ULONG old;

    if (hook_data_2.library)
    {
     if (hook_data_2.address)
     {
      if (VirtualProtect(hook_data_2.address,sizeof(hook_data_2.content),PAGE_EXECUTE_READWRITE,&old))
      {
       CopyMemory(hook_data_2.address,hook_data_2.content,sizeof(hook_data_2.content));
       VirtualProtect(hook_data_2.address,sizeof(hook_data_2.content),old,&old);
       FlushInstructionCache(GetCurrentProcess(),hook_data_2.address,sizeof(hook_data_2.content));
      }
     }
    }
}

void hook_take_2()
{
ULONG old;
ULONG index;

    if (hook_data_2.library)
    {
     if (hook_data_2.address)
     {
      if (VirtualProtect(hook_data_2.address,sizeof(hook_data_2.content),PAGE_EXECUTE_READWRITE,&old))
      {
       index = 0;

       *(PUCHAR)((ULONG)hook_data_2.address + index) = 0xE9;
       index += sizeof(UCHAR);

       *(PULONG)((ULONG)hook_data_2.address + index) = (ULONG)hook_ours_2 - (ULONG)hook_data_2.address - index - sizeof(ULONG);
       index += sizeof(ULONG);

       if (index > sizeof(hook_data_2.content)) ExitProcess(ERROR_PROCESS_ABORTED);

       VirtualProtect(hook_data_2.address,sizeof(hook_data_2.content),old,&old);
       FlushInstructionCache(GetCurrentProcess(),hook_data_2.address,sizeof(hook_data_2.content));
      }
     }
    }
}

void hook_exit_2()
{
    EnterCriticalSection(&hook_data_2.section);

    if (hook_data_2.library)
    {
     hook_give_2();
     FreeLibrary(hook_data_2.library);
     hook_data_2.library = NULL;
     hook_data_2.address = NULL;
    }

    LeaveCriticalSection(&hook_data_2.section);
    DeleteCriticalSection(&hook_data_2.section);
}

void hook_init_2()
{
    zeroize(hook_data_2);
    InitializeCriticalSection(&hook_data_2.section);
    EnterCriticalSection(&hook_data_2.section);

    hook_data_2.library = LoadLibrary("mf.dll");
    if (hook_data_2.library)
    {
     hook_data_2.address = GetProcAddress(hook_data_2.library,"MFCreateStandardQualityManager");
     if (hook_data_2.address)
     {
      CopyMemory(hook_data_2.content,hook_data_2.address,sizeof(hook_data_2.content));
      hook_take_2();
     }
    }

    LeaveCriticalSection(&hook_data_2.section);
}
