// manage of quality

struct data_of_quality
{
IMFTopology * topology;
long cleans_of_audio;
long cleans_of_video;
long passes_of_audio;
long passes_of_video;
};

IMFTopology * read_the_topology();
long read_then_zeroize_the_cleans_of_audio();
long read_then_zeroize_the_cleans_of_video();
long read_then_zeroize_the_passes_of_audio();
long read_then_zeroize_the_passes_of_video();

class qualifier : public IMFQualityManager
{
private:
    long m_count; // count of reference
    IMFQualityManager * m_object;

public:
    qualifier(IMFQualityManager * object);
    ~qualifier();

public:
    ULONG STDMETHODCALLTYPE AddRef();
    ULONG STDMETHODCALLTYPE Release();
    HRESULT STDMETHODCALLTYPE QueryInterface(REFIID demand, void ** object);

public:
    HRESULT STDMETHODCALLTYPE NotifyPresentationClock(IMFPresentationClock * clock);
    HRESULT STDMETHODCALLTYPE NotifyProcessInput(IMFTopologyNode * node, long index, IMFSample * sample);
    HRESULT STDMETHODCALLTYPE NotifyProcessOutput(IMFTopologyNode * node, long index, IMFSample * sample);
    HRESULT STDMETHODCALLTYPE NotifyQualityEvent(IUnknown * object, IMFMediaEvent * event);
    HRESULT STDMETHODCALLTYPE NotifyTopology(IMFTopology * topology);
    HRESULT STDMETHODCALLTYPE Shutdown();

private:
    void notify_input(IMFTopologyNode * node, DWORD index, IMFSample * sample);
};
