// implementation of declaration

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include "resource.h"
#include "stater.h"

BEGIN_MESSAGE_MAP(stater, CStatusBar)
END_MESSAGE_MAP()

stater::stater()
{
}

stater::~stater()
{
}

void stater::initialize()
{
// identifiers of indicators
// they must not duplicate other resources
// they were added as symbols of resources
// but they have not templates of resources
unsigned int indicators[] =
{
ID_STATUS_POSITION, // position of media
ID_STATUS_SOUND,    // sound of audio
ID_STATUS_SCALE,    // scale of video
ID_STATUS_SPEED,    // speed of media
ID_SEPARATOR        // line of message
};

    // learn
    CDC context;
    context.CreateCompatibleDC(NULL);
    context.SetMapMode(MM_TEXT);
    CFont * font = GetFont();
    font = context.SelectObject(font);
    TEXTMETRIC metric = {};
    context.GetTextMetrics(&metric);
    font = context.SelectObject(font);
    context.DeleteDC();

    // check
    ASSERT(metric.tmPitchAndFamily == 0);

    SetIndicators(indicators,RTL_NUMBER_OF(indicators));

    SetPaneInfo(0,indicators[0],SBPS_NORMAL,metric.tmAveCharWidth * 18);   // hard coded value
    SetPaneInfo(1,indicators[1],SBPS_NORMAL,metric.tmAveCharWidth * 11);   // hard coded value
    SetPaneInfo(2,indicators[2],SBPS_NORMAL,metric.tmAveCharWidth * 11);   // hard coded value
    SetPaneInfo(3,indicators[3],SBPS_NORMAL,metric.tmAveCharWidth * 11);   // hard coded value
    SetPaneInfo(4,indicators[4],SBPS_NORMAL,metric.tmAveCharWidth * 1000); // for grip in line

    // set minimum-height
    int horizontal,vertical,spacing,height;
    GetStatusBarCtrl().GetBorders(horizontal,vertical,spacing);
    height = metric.tmHeight + vertical + vertical + spacing;
    GetStatusBarCtrl().SetMinHeight(height);
}
