// implementation of declaration

// it is more simple than CSingleLock

// it must be defined as variable in scope
// then define does lock till end of scope

// you must give name to variable in definition
// or else it does not remain till end of scope
// temporary object does remain till end of use
// in this state that use does end at semicolon

// because of calls from threads at same time
// as much as we can, we included few headers

#include <sdkddkver.h>
#include <windows.h>
#include "lockee.h"
#include "locker.h"

locker::locker(lockee * object)
{
    m_object = object;

    // check of error is by it
    EnterCriticalSection(&m_object->m_object);
}

locker::~locker()
{
    // check of error is by it
    LeaveCriticalSection(&m_object->m_object);

    m_object = NULL;
}
