// operations of media

CString rate_to_text(unsigned long width, unsigned long height);
CString time_to_text(MFTIME time, const bool shorter);
CString type_to_text(const GUID major, const GUID minor);
CString audio_to_text(const int channel, const int depth, const int rate);
CString video_to_text(const int width, const int height, const int depth, const int rate);
unsigned long depth_of_video(const unsigned long type);
CString capabilities_of_audio();
CString capabilities_of_video();
HRESULT get_type(IMFTopologyNode * node, IMFMediaType ** type);
CString get_format(IMFMediaType * type);
CString get_formats(IMFTopology * topology);
CString get_file(IMFPMediaItem * item);
CString get_attributes(IMFPMediaItem * item);
CString get_components(IMFPMediaItem * item);
CString get_properties(IMFPMediaItem * item);
void normalize_rectangle(MFVideoNormalizedRect & rectangle);
void close_stream(IMFPMediaItem * item, const GUID type);
void sort_nodes(IMFTopology * topology, CTypedPtrArray <CPtrArray, IMFTopologyNode *> * data);
